package de.hdm_stuttgart.mi.sd1.binomial;

public class Binomial {

  static public long binomial(int n, int k) {
    
    if (0 == k || n == k) {           // Termination condition
      return 1;
    } else {                          // Reducing statement
      return binomial(n - 1, k) +
          binomial(n - 1, k - 1);
    }
  }

  static public long binomialLoop(int n, int k) {

    // Optimization avoiding arithmetic overflow by making use of:
    //             n        n
    //           (   ) =  (   )
    //             k       n-k
    //
    if (n / 2 < k) {
      k = n - k;
    }

    // Numerator product n (n - 1) ... (n - k + 1)
    long numerator = 1;
    for (int i = n - k + 1; i <= n; i++) {
      numerator *= i;
    }
    return numerator / factorial(k);
  }

  public static long factorial(int n) {
    long ret = 1;

    for (int i = 2; i <= n; i++) {
      ret *= i;
    }
    return ret;
  }

}
